<?php

	require_once 'lib/func.class-alias.php';
	require_once 'lib/class.domdoc-xmlelement.php';


	if (!class_exists('XMLElement'))
	{
		$klass = 'LegacyXMLElement';
		$debugMode  = isset($_GET['debug']);
		$legacyMode = isset($_GET['use-legacy-xmlelement']);

		if (class_exists('Frontend') && !$debugMode && !$legacyMode)
			$klass = 'DomDocXMLElement';

		class_alias($klass, 'XMLElement');
	}


	class extension_domdoc_xmlelement extends Extension{

		public function about()
		{
			return array(
				'name' => 'XMLElement (DomDocument powered)',
				'version' => '1.0',
				'release-date' => '2010-11-05',
				'author' => array(
					'name' => 'Marco Sampellegrini',
					'email' => 'm@rcosa.mp'
				)
			);
		}

		public function getSubscribedDelegates()
		{
			return array(
				array(
					'page'		=> '/frontend/',
					'delegate'	=> 'FrontendOutputPostGenerate',
					'callback'	=> 'FrontendOutputPostGenerate'
				)
			);
		}

		public function FrontendOutputPostGenerate($context)
		{
			$profiler = Frontend::instance()->Profiler;
			$xml = $profiler->retrieveByMessage('XML Generation');
			$tot = $profiler->retrieveTotalRunningTime();
			$mem = General::formatFilesize($profiler->retrieveTotalMemoryUsage());
			$legacyMode = isset($_GET['use-legacy-xmlelement']);

			$context['output'] .= 
				"<!--\nSome stats using '". get_parent_class('XMLElement'). "' \n\n".
				__('XML Generation Function'). ": \t\t". $xml[1]. "\n".
				__('Output Creation Time'). ": \t\t\t". $tot. "\n".
				__('Total Memory Usage'). ": \t\t\t". $mem.
				(!$legacyMode ?
				"\n\nAppend '?use-legacy-xmlelement' to the URL and compare :)"
				: ''). ' -->';
		}
	}
